package com.madeu.crm.appointment.ctrl;

import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.servlet.ModelAndView;

import com.madeu.constants.Constants;
import com.madeu.crm.appointment.service.AppointmentService;
import com.madeu.crm.contentsBbs.service.ContentsBbsService;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.web.webloghistory.WebLogHistoryService;
import com.madeu.util.HttpUtil;
import com.madeu.util.RequestLogUtil;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Controller
public class AppointmentController extends ManagerDraftAction {

    @Autowired
    private AppointmentService appointmentService;

    @Autowired
    private WebLogHistoryService webLogHistoryService;

    /**
     * 홈페이지 시술예약(쁘띠) 리스트 화면으로 이동.
     *
     * @param request
     * @param response
     * @return
     */
    @PostMapping("/appointment/moveAppointmentList.do")
    public String  moveAppointmentList(HttpSession session, HttpServletRequest request, HttpServletResponse response, Model model) {
        log.debug("AppointmentController  selectListWebTreatmentPetitIntro START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = null;

        try{
            if(!webCheckLogin(session)){
                return "/web/login/logout";
            }
            else {
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = appointmentService.moveAppointmentList(paramMap);
                model.addAttribute("selectUseYn", map.get("selectUseYn"));
                model.addAttribute("insertUseYn", map.get("insertUseYn"));
                model.addAttribute("updateUseYn", map.get("updateUseYn"));
                model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
                model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
            }
        } catch (Exception e) {
            e.printStackTrace();
            return "/web/login/logout";
        }
        log.debug("AppointmentController  selectListWebTreatmentPetitIntro END");

        
        return "/web/appointment/AppointmentSelectList";
    }

    /**
     * 홈페이지 시술예약(쁘띠) 정보 리스트 조회
     *
     * @param request
     * @param response
     * @return
     */
    @PostMapping("/appointment/getAppointmentList.do")
    public ModelAndView getAppointmentList(HttpSession session, HttpServletRequest request, HttpServletResponse response) {

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = appointmentService.getAppointmentList(paramMap);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("AppointmentController selectListWebTreatmentPetit END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }

    
}


